<?php

namespace Controllers;

use Zeedhi\Framework\Report\ReportService;
use Zeedhi\Framework\DTO;

class ListagemTabelaPrecos extends \Zeedhi\Framework\Controller\Report {

  protected $environment;
  protected $birtStrategy;

  public function __construct(ReportService $reportService, $birtStrategy, $environment) {
      $this->birtStrategy = $birtStrategy;
      $this->environment = $environment;
      parent::__construct($reportService);
  }

  protected $reportMapping = array (
    'COC21002' =>
    array (
      'strategy' => 'BIRT',
      'parameterMapping' =>
      array (
        "CDFILIAL"         => "CDFILIAL",
        "CDCIA"            => "CDCIA",
        "IDVIGENCIA"       => "IDVIGENCIA",
        "NRORG"            => "NRORG"
      ),
      'reportName'
    ),
    'COC21003' =>
    array (
      'strategy' => 'BIRT',
      'parameterMapping' =>
      array (
        "CDFILIAL"         => "CDFILIAL",
        "CDCIA"            => "CDCIA",
        "IDVIGENCIA"       => "IDVIGENCIA",
        "NRORG"            => "NRORG",
        "DATAINI"          => "DATAINI",
        "DATAFIN"          => "DATAFIN",
        "STATUS"           => "STATUS"
      ),
      'reportName'
    ),
    'COC21004' =>
    array (
      'strategy' => 'BIRT',
      'parameterMapping' =>
      array (
        "CDFILIAL"              => "CDFILIAL",
        "CDCIA"                 => "CDCIA",
        "NRTABPRECO"            => "NRTABPRECO",
        "NRORG"                 => "NRORG",
        "NRSERVICOCIAFILIPRECO" => "NRSERVICOCIAFILIPRECO",
        "CDCLASSE"              => "CDCLASSE",
        "CDCICLO"               => "CDCICLO",
        "DTREFERENCIA"          => "DTREFERENCIA",
        "SOMENTE_VIGENTES"      => "SOMENTE_VIGENTES"
      ),
      'reportName'
    ),
    'COC21005' =>
    array (
      'strategy' => 'BIRT',
      'parameterMapping' =>
      array (
        "CDFILIAL"              => "CDFILIAL",
        "CDCIA"                 => "CDCIA",
        "NRTABPRECO"            => "NRTABPRECO",
        "NRORG"                 => "NRORG",
        "NRSERVICOCIAFILIPRECO" => "NRSERVICOCIAFILIPRECO",
        "CDCLASSE"              => "CDCLASSE",
        "CDCICLO"               => "CDCICLO",
        "DTREFERENCIA"          => "DTREFERENCIA",
        "SOMENTE_VIGENTES"      => "SOMENTE_VIGENTES"
      ),
      'reportName'
    ),
    'COC21006' =>
    array (
      'strategy' => 'BIRT',
      'parameterMapping' =>
      array (
        "CDFILIAL"              => "CDFILIAL",
        "CDCIA"                 => "CDCIA",
        "NRTABPRECO"            => "NRTABPRECO",
        "NRORG"                 => "NRORG",
        "NRSERVICOCIAFILIPRECO" => "NRSERVICOCIAFILIPRECO",
        "CDCLASSE"              => "CDCLASSE",
        "CDCICLO"               => "CDCICLO",
        "DTREFERENCIA"          => "DTREFERENCIA",
        "SOMENTE_VIGENTES"      => "SOMENTE_VIGENTES",
        "EXIB_PRECO_PROP"       => "EXIB_PRECO_PROP"
      ),
      'reportName'
    )
  );

  public function beforeProcessReport(DTO\Request\Row $request, DTO\Response $response) {
    $row = $request->getRow();
    $row['__report_name'] = $row['REPORTNAME'];
    $this->birtStrategy->setReportFormat($row['REPORTFORMAT']);
    $row['NRORG'] = $this->environment->getNrOrgTrab();
  }
  
}